/* inet.h -- inet headers */

#ifndef INET_H
#define INET_H

/* includes */
#include "ivac.h"
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>

/* net specific includes */
#include <netinet/in.h>

/* defines */
#define MAX_CONNECTIONS 32

#define IP_DIGITS 16
#define C_IN_USE (1<<0)
#define C_INFO_A (1<<1)
#define C_SOCKET (1<<2)
#define C_ESTABL (1<<3)
#define C_HANGUP (1<<4)

#define SEND_I_MAX 128
#define SEND_I_NAME 'n'
#define SEND_I_G_CAP 'g'
#define SEND_I_AV_CAP 'c'

/* net specific variables */
typedef s_connection {
  int fd;
  char name[CHAR_USERNAME];
  char ip[IP_DIGITS];
  in_port_t port;
  unsigned char status;
  unsigned char cap; /* general capabilities */
  unsigned short avcap; /* audio/video capabilities */
} t_connection;

typedef s_net {
  int l_fd; /* listen file descriptor */
  in_port_t l_port;
  unsigned char cap;
  unsigned short avcap;
  /* limited connections by now -- replaced by list management later */
  int c_count;
  t_connection connection[MAX_CONNECTIONS];
  unsigned int sendmask; /* 32 bits for maximum of 32 connections */
} t_net;

#endif

